<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit;
} // Exit if accessed directly

class APPMAKER_WC_bookings {
    public $product;

    public function __construct() {
        add_filter( 'appmaker_wc_product_fields', array( $this, 'product_fields_response_fix' ),2,2);
        add_filter( 'appmaker_wc_add_to_cart_validate', array( $this, 'check_date_field' ), 2, 2 );
        
    }
    public function check_date_field( $return, $params )
    {
        $date= $params['date'];
        if(!empty($date)) {
            //$date= str_replace(' GMT 0530 (IST)','',$date);
            preg_match("/([a-zA-z]{3}[\s][\d]{2}[\s][\d]{4}[\s][\d\:]+)[\s](.*)/i", $date, $new_date);
            $new_date = $new_date[1];
            $timezone = $new_date[2];
            $date = new DateTime($new_date, new DateTimeZone($timezone));
            $date = $date->format('d-m-Y');
        }
      // $date=date("d-m-Y",strtotime($date));
        $time= current_time( 'timestamp' );
        $time=date('g:i a',$time);

        $_POST['wc_bookings_field_start_date_time']=$time;

        $date = explode('-', $date);

      $_POST['wc_bookings_field_start_date_day']=$date[0];
      $_POST['wc_bookings_field_start_date_month']=$date[1];
      $_POST['wc_bookings_field_start_date_year']= $date[2];

      $_POST['wc_bookings_field_duration']=$params['wc_bookings_field_duration'];

        return $return;
    }

    public function product_fields_response_fix($fields,$product)
    {
        $min_date=date('d-m-Y');
        $field = array();

        if ($product->is_type('booking')) {


            if ( 'customer' ==$product->get_duration_type() ) {

              $field[ 'wc_bookings_field_duration']= array(
                    'label' => 'Minimum duration',
                    'type' => 'number',
                    'min' =>$product->get_min_duration(),
                    'max' =>$product->get_max_duration(),
                    'step'  => 1,
                    'value'=>$product->get_min_duration(),
                    'required'=>true,

                );

               }

                $field['date'] = array(
                        'type' => 'datepicker',
                        'label' => 'Booking Date',
                        'required' => true,
                        'minDate'=>$min_date,
                        'default' =>$min_date,
                        'placeholder'=>$min_date,

                );

            }
        $fields = APPMAKER_WC_Dynamic_form::get_fields($field, 'product');
        return $fields;
    }
}
new APPMAKER_WC_bookings();

