<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit;
} // Exit if accessed directly
class APPMAKER_WC_Order_Delivery_Date
{
    public function __construct()
    {
       // add_action('appmaker_wc_before_checkout',array($this, 'checkout_fields_response'));
       add_filter('appmaker_wc_checkout_fields', array( $this,'checkout_fields_response_fix'), 10, 2 );
    }
    public function get_delivery_intervals(){
        $from = get_option( 'orddd_delivery_from_hours' );     
        $from=$from.date(':i');
        $from=(strtotime($from));
        $to =  get_option( 'orddd_delivery_to_hours' ); 
        $to=$to.date(':i');  
        $to=strtotime($to);  
        $return = array();
        do{
            $time = date('h:i A',$from);
            $return[$time] = $time;
            $from = strtotime("+15 minutes", $from);
        }while($from<=$to);
        return $return;
      
    }
        
    public function checkout_fields_response_fix( $return, $section )
    {
        $additional_fields = array();
        $min_date=date('d-m-Y', strtotime($date. ' + 1 days'));                          
        if( 'on' == get_option( 'orddd_enable_same_day_delivery' ) ) {
            $min_date=date('d-m-Y');        
         }         
       
       // $result = array ( __( "Select a time slot", "order-delivery-date" ) );
        if ( $section === 'order' ) {
            $delivery_enabled = orddd_common::orddd_is_delivery_enabled();
            $is_delivery_enabled = 'yes';
            if ($delivery_enabled == 'no') {
                $is_delivery_enabled = 'no';
            }
            if ($is_delivery_enabled == 'yes') {
                $additional_fields['e_deliverydate'] = array(
                    'type' => 'datepicker',
                    'label' => 'Select date',
                    'required' => true,
                    'minDate' => $min_date,
                    'placeholder' => 'Select date',
                    'default' => $min_date,

                );
                $validate_wpefield = false;
    				if (  get_option( 'orddd_time_slot_mandatory' ) == 'checked' ) {
    					$validate_wpefield = true;
                    }
                    if( is_cart() ) {
                        $custom_attributes = array( 'disabled'=>'disabled', 'style'=>'cursor:not-allowed !important;max-width:300px;' );
                    } else {
                        $custom_attributes = array( 'disabled'=>'disabled', 'style'=>'cursor:not-allowed !important;' );
                    }    				
                $additional_fields['time_slot'] = array(
                    'type' => 'select',
                    'label' => 'Delivery Time',
                    'required' =>$validate_wpefield,
                    'placeholder' => 'select time',
                    'options'=> $this->get_delivery_intervals(),
                    'custom_attributes' => $custom_attributes,
                );
            }
        }
        return array_merge( $additional_fields, $return );
    }
}
new APPMAKER_WC_Order_Delivery_Date();